#!/usr/bin/env python
# -*- encoding: utf-8 -*-
'''
@Date:2022/09/14 09:54:18
'''
import sys
sys.path.append('.')

from models.medicament_models import EntityStockRecord
from db_logic.medicament import BllMedicament
from db_logic.db_base import Repository
from Common.Utils import Utils
import json


class BllStockRecord(Repository):

    def __init__(self, entityType=EntityStockRecord):
        return super().__init__(entityType)
    

    def get_list_info(self, page_param, client_id):
        filter_base = ""
        if client_id:
            filter_base += f" client_id='{client_id}'"
        if filter_base:
            filter_base = f" where {filter_base} "
        
        sql_all = f"""
            select * from rms_stock_record {filter_base}
        """
        try:
            count_number = len(self.execute(sql_all).fetchall())
        except:
            count_number = 0
        page_param.totalRecords = count_number
        page_sql = Utils.sql_paging_assemble(sql_all, page_param)
        return self.execute(page_sql).fetchall()
    
    def set_stock_info(self, client_id, client_code, user_info):
        # 查询当前在库试剂信息
        sql_base1 = f"""
            select name,purity,speci,count(*) stock_num
            from rms_medicament where client_id='{client_id}' and `status`=1 GROUP BY `name`,purity,speci

        """
        data_list = Utils.msyql_table_model(self.execute(sql_base1).fetchall())
        try:
            total_num = 0
            for i in data_list:
                total_num += int(i["stock_num"])
            obj = EntityStockRecord(
                user_id=user_info.user_id,
                create_date=Utils.get_str_datetime(),
                total=total_num,
                client_code=client_code,
                client_id=client_id,
                medicament_info=json.dumps(data_list)
            )
            self.insert(obj)
            return True
        except Exception as error:
            print(error)
            return False





        

